//************************************************************
//  University of Patras 
//	Department of Electrical Engineering & Computer Technology
//
//	Course: Parallel Programming in AI 
//	Week 01: Code Optimization
//
//  Description: Optimization effects
//	Author: Evangelos Dermatas
//	v0.1
/*
*********************************************************************
gcc -v:	gcc version 9.3
OS: 	Linux Ubuntu 18.04
CPU:	8-core, Intel(R) Core(TM) i7-2630QM CPU @ 2.00GHz, 3991 BogoMips
*********************************************************************
Compiling:	gcc ex3.c -o ex3
Executing:	time ./ex3

*/

// **************************************************************

#include <stdio.h>
#include <stdlib.h>

#define N	10000

int A[N][N] ;
int B[N][N] ;
int C[N][N] ;

// ***************************************************************************
void setValMat( int a[N][N] )
{
	int i, j ;
		for( i = 0 ; i < N ; i++ )
			for( j = 0 ; j < N ; j++ )
		    a[i][j] = (rand() % 100) - 50 ;

}

// ***************************************************************************
void addMat( int a[N][N], int b[N][N], int c[N][N] )
{
	int i, j ;

    	for( i = 0 ; i < N ; i++ )
	for( j = 0 ; j < N ; j++ )
	    	c[i][j] = a[i][j] + b[i][j] ;

}

// ***************************************************************************
int innerProdMat( int a[N][N], int b[N][N] )
{
	int i, j, sum = 0 ;

		for( i = 0 ; i < N ; i++ )
		    for( j = 0 ; j < N ; j++ )
		    sum += a[i][j]*b[i][j] ;
	return sum ;
}



// **************************************************************
int main(void)
{
double t1, t2, ttot = 0, t ;
int res ;

	setValMat( A ) ;
	setValMat( B ) ;
	addMat( A, B, C ) ;
	res = innerProdMat( A, C ) ;
	printf( "innerProdMat  %d\n", res ) ;

	return 0 ;
}
